/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

int main(int argc, char **argv)
{
	FILE	*fp;
	FILE	*fpout;
	static unsigned char	buffer[16384];
	int	length, result;
	unsigned int	file_length = 0;
	unsigned long long	clip_start;
	unsigned int	clip_length;

	if (argc != 5) {
		fprintf(stderr, "usage: clip <infile> <outfile> <start offset> <length>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fp = fopen(argv[1], "rb");
	if (fp == 0) {
		fprintf(stderr, "Cannot open input file <%s>\n", argv[1]);
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[2], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[2]);
		exit(-1);
	}

	clip_start = _atoi64(argv[3]);
	clip_length = atoi(argv[4]);

	result = _fseeki64(fp, clip_start, SEEK_SET);
	while(!feof(fp))  {
		length = fread(&buffer[0], 1, 16384, fp);
		file_length += length;
		if (file_length <= clip_length)  {
			fwrite(&buffer[0], 1, length, fpout);
		}
		else  {
			fwrite(&buffer[0], 1, (length - (file_length - clip_length)), fpout);
			break;
		}
	}
	fclose(fp);
	fclose(fpout);
	return 0;
}
